import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;


import javax.swing.JPanel;


/**
 * Visualisation de la course d'escargots.
 */

public class CourseEscargotsView extends JPanel {
	private int depart= 20;
	CourseEscargotsModele modele;
	
	public CourseEscargotsView(CourseEscargotsModele modele) {
		this.modele= modele;
	}
	
	
	/* (non-Javadoc)
	 * @see java.awt.Component#getPreferredSize()
	 */
	public Dimension getPreferredSize() {
		return new Dimension(640,400);
	}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
	 */
	protected void paintComponent(Graphics g) {
	    // On efface le fond.
		super.paintComponent(g);
		// On rcupre la surface de dessin.
		Graphics2D g2d= (Graphics2D)g;

		// On prpare le dessin des lignes de dpart et d'arrive
		float pointilles[]= {10f,10f};
		g2d.setColor(Color.YELLOW);
		g2d.setStroke(new BasicStroke(1f,
					      BasicStroke.CAP_SQUARE,
			BasicStroke.JOIN_ROUND,
			10.0f, pointilles,0f));
		int y1, y2;
		y1= 0;
		y2= getHeight();
		// Dessine les lignes de dpart et d'arrive
		g2d.drawLine(depart, y1, depart,y2);
		g2d.setColor(Color.RED);
		g2d.drawLine(depart+modele.getDistance(), y1, depart+modele.getDistance(),y2);
		// On prpare le dessin des escargots
		g2d.setColor(Color.LIGHT_GRAY);
		g2d.setStroke(new BasicStroke(10f));
		// on dessine les escargots
		for (int i= 0; i <modele.getEscargots().length; i++) {
			Escargot c= modele.getEscargots()[i];
			g2d.drawLine(depart,c.getY(), c.getX()+depart, c.getY());
		}
		
	}
}
